#include "postgres.h"
#include "fmgr.h"
#include "utils/palloc.h"
#include <sys/time.h>

PG_MODULE_MAGIC;
PG_FUNCTION_INFO_V1(valgrind_demo_clock);

Datum
valgrind_demo_clock(PG_FUNCTION_ARGS)
{
	int64 cnt = PG_GETARG_INT64(0);
	int64 rc = 0;
	void** chunks;
	struct timeval cl, cle;
	gettimeofday(&cl, NULL);

	chunks = (void**)palloc(sizeof(void*)*cnt);

	for (int64 i = 0; i < cnt; ++i)
		chunks[i] = palloc(64);

	for (int64 i = 0; i < cnt; ++i)
		chunks[i] = repalloc(chunks[i], 62);

	for (int64 i = 0; i < cnt; ++i)
		pfree(chunks[i]);

	pfree(chunks);

  gettimeofday(&cle, NULL);
  rc = (cle.tv_sec - cl.tv_sec) * 1e3 + (cle.tv_usec - cl.tv_usec) / 1e3;
  // rc = (cle.tv_sec - cl.tv_sec) * (long)1e9 + (cle.tv_nsec - cl.tv_nsec);
  PG_RETURN_INT64(rc);
}

